.\"***************************************************************************
.\" Copyright 2018-2022,2023 Thomas E. Dickey                                *
.\" Copyright 1998-2006,2010 Free Software Foundation, Inc.                  *
.\"                                                                          *
.\" Permission is hereby granted, free of charge, to any person obtaining a  *
.\" copy of this software and associated documentation files (the            *
.\" "Software"), to deal in the Software without restriction, including      *
.\" without limitation the rights to use, copy, modify, merge, publish,      *
.\" distribute, distribute with modifications, sublicense, and/or sell       *
.\" copies of the Software, and to permit persons to whom the Software is    *
.\" furnished to do so, subject to the following conditions:                 *
.\"                                                                          *
.\" The above copyright notice and this permission notice shall be included  *
.\" in all copies or substantial portions of the Software.                   *
.\"                                                                          *
.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS  *
.\" OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF               *
.\" MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.   *
.\" IN NO EVENT SHALL THE ABOVE COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,   *
.\" DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR    *
.\" OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR    *
.\" THE USE OR OTHER DEALINGS IN THE SOFTWARE.                               *
.\"                                                                          *
.\" Except as contained in this notice, the name(s) of the above copyright   *
.\" holders shall not be used in advertising or otherwise to promote the     *
.\" sale, use or other dealings in this Software without prior written       *
.\" authorization.                                                           *
.\"***************************************************************************
.\"
.\" $Id: curs_scroll.3x,v 1.28 2023/08/19 19:47:52 tom Exp $
.TH curs_scroll 3X 2023-08-19 "ncurses 6.4" "Library calls"
.ie \n(.g .ds `` \(lq
.el       .ds `` ``
.ie \n(.g .ds '' \(rq
.el       .ds '' ''
.na
.hy 0
.SH NAME
\fBscroll\fP,
\fBscrl\fP,
\fBwscrl\fP \- scroll a \fBcurses\fP window
.ad
.hy
.SH SYNOPSIS
\fB#include <curses.h>\fP
.sp
\fBint scroll(WINDOW *\fIwin\fB);\fR
.sp
\fBint scrl(int \fIn\fB);\fR
.br
\fBint wscrl(WINDOW *\fIwin\fB, int \fIn\fB);\fR
.SH DESCRIPTION
The \fBscroll\fP routine scrolls the window up one line.
This involves moving
the lines in the window data structure.
As an optimization, if the scrolling
region of the window is the entire screen,
the \fIphysical screen\fP may be scrolled at the same time.
.PP
For positive \fIn\fP, the \fBscrl\fP and \fBwscrl\fP routines scroll the
window up \fIn\fP lines (line \fIi\fP+\fIn\fP becomes \fIi\fP); otherwise
scroll the window down \fIn\fP lines.
This involves moving the lines in the
window character image structure.
The current cursor position is not changed.
.PP
For these functions to work, scrolling must be enabled via \fBscrollok\fP(3X).
.SH RETURN VALUE
These routines return \fBERR\fP upon failure, and \fBOK\fP (SVr4 only specifies
"an integer value other than \fBERR\fP") upon successful completion.
.PP
X/Open defines no error conditions.
.PP
This implementation returns an error
if the window pointer is null, or
if scrolling is not enabled in the window, e.g., with \fBscrollok\fP(3X).
.SH NOTES
Note that \fBscrl\fP and \fBscroll\fP may be macros.
.PP
The SVr4 documentation says that the optimization of physically scrolling
immediately if the scroll region is the entire screen \*(``is\*('' performed,
not \*(``may be\*('' performed.
This implementation deliberately does not guarantee
that this will occur, to leave open the possibility of smarter
optimization of multiple scroll actions on the next update.
.PP
Neither the SVr4 nor the XSI documentation specify whether the current
attribute or
current color-pair of blanks generated by the scroll function is zeroed.
Under this implementation it is.
.SH PORTABILITY
The XSI Curses standard, Issue 4 describes these functions.
.SH SEE ALSO
\fBcurses\fP(3X), \fBcurs_outopts\fP(3X)
